#ifndef _IPHOTO_
#define _IPHOTO_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iList"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-list.h"

#include <cstdlib>
#include <stdlib.h>
#include <string>

#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

#include <gio/gio.h>


class iFolder : public iList
{
	private:
	vector<string>			m_files;
	vector<string>			m_size;
	
	public:
	virtual 	GdkPixbuf*		get_pixbuf  		( void );
	virtual 	int 			get_n_items 		( ) ;
	virtual 	string 			get_item			( int i, int j ) ;
	virtual 	int 			get_n_columns 		( void );
			  	int				get_folder_files	( string dir, vector<string> &files );


};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iList* create() {		
	printf("Creating iFolder...\n");
    return new iFolder;
}

extern "C" void destroy(iList* p) {
	printf("Destroying iList...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			//The priority is used to know wich plugin use if there are more than one that can handle the same
			//filetype, 1 is the lower priority
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype_itself = { NAME OF PLUGIN, MIME TYPE IT SUPPORTS, INHERTED CLASS, PRIORITY}

			plugin_filetype itself = { PLUGIN_NAME, "inode/directory","list",1};		// Initial filetype

			factory_list[itself.name] = create;		    // Register the plugin
			factoryDestroy_list[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

